﻿using EJGrid.Models;
using Microsoft.OData.Edm;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Http;
using System.Web.OData.Batch;
using System.Web.OData.Builder;
using System.Web.OData.Extensions;

namespace EJGrid
{
    public static class WebApiConfig
    {
        public static void Register(HttpConfiguration config)
        {
            HttpServer server = new HttpServer(config);
            IEdmModel model;
            using (NORTHWNDEntities context = new NORTHWNDEntities())
            {
                model = GetModel();
            }

            // Create our batch handler and associate it with the OData service.
            ODataBatchHandler batchHandler = new DefaultODataBatchHandler(GlobalConfiguration.DefaultServer);
            config.MapODataServiceRoute("odata", "odata", model, batchHandler);
            //config.MapHttpAttributeRoutes();
            config.EnsureInitialized();
            //config.Routes.MapHttpRoute(
            //    name: "DefaultApi",
            //    routeTemplate: "api/{controller}/{id}",
            //    defaults: new { id = RouteParameter.Optional }
            //);
            //config.MapODataServiceRoute("odata", "odata", model: GetModel());
        }
        public static Microsoft.OData.Edm.IEdmModel GetModel()
        {
            ODataModelBuilder builder = new ODataConventionModelBuilder();

            //builder.EntitySet<OrderID>("Address");
            //builder.EntitySet<AddressType>("AddressType");
            //builder.EntitySet<BusinessEntity>("BusinessEntity");
            //builder.EntitySet<BusinessEntityAddress>("BusinessEntityAddress");
            //builder.EntitySet<BusinessEntityContact>("BusinessEntityContact");
            //builder.EntitySet<ContactType>("ContactType");
            //builder.EntitySet<CountryRegion>("CountryRegion");
            //builder.EntitySet<EmailAddress>("EmailAddress");
            //builder.EntitySet<Password>("Password");
            //builder.EntitySet<Person>("Person");
            //builder.EntitySet<PersonPhone>("PersonPhone");
            //builder.EntitySet<PhoneNumberType>("PhoneNumberType");
            //builder.EntitySet<StateProvince>("StateProvince");

            var order = builder.EntitySet<Order>("Orders");
            var Employee = builder.EntitySet<EmployeeTerritory>("Employees");
            //order.EntityType.HasKey(c => c.OrderID);
            FunctionConfiguration myFirstFunction = order.EntityType.Collection.Function("MyFirstFunction");
            myFirstFunction.ReturnsCollectionFromEntitySet<Order>("Orders");
            FunctionConfiguration myFirstFunction1 = Employee.EntityType.Collection.Function("MyFirstFunction1");
            myFirstFunction1.ReturnsCollectionFromEntitySet<EmployeeTerritory>("Employees");
            return builder.GetEdmModel();
        }
    }

}
